# Class MarkupEntityBase`Abstract`

Base class for markup entities and Markup sheets in the Markup API.

#### Hierarchy (View Summary)

- MarkupEntityBase
  - MarkupSheet2D
  - MarkupEntity

#### Implements

- MergableObject<MarkupEntityBase>

##### Index

### Properties

id
properties

### Accessors

isEnabled

### Methods

clone
isEqual
markAsDeleted
markAsUpdated
onAdded
onDelete
onUpdate

## Properties

### `Readonly` id

id: string

Implementation of MergableObject.id

### `Readonly` properties

properties: Map<string, MarkupProperty> = ...

## Accessors

### `Abstract` isEnabled

- get isEnabled(): boolean

  Returns `true` if the entity and the sheet it belongs to are both enabled, otherwise `false`.

  #### Returns boolean

- set isEnabled(b: boolean): void

  Sets if entity is enabled

  #### Parameters

  - b: boolean

  #### Returns void

## Methods

### `Abstract` clone

- clone(): MarkupEntityBase

  Makes a deep copy of this entity

  #### Returns MarkupEntityBase

  Implementation of MergableObject.clone

### `Abstract` isEqual

- isEqual(o: MarkupEntityBase): boolean

  Compares if this entity is equal to another entity

  #### Parameters

  - o: MarkupEntityBase

  #### Returns boolean

  Implementation of MergableObject.isEqual

### `Abstract` markAsDeleted

- markAsDeleted(): boolean

  Marks the entity as deleted in the MarkupSheet2D.

  #### Returns boolean

  `true` if object was deleted. Otherwise `false`.

### `Abstract` markAsUpdated

- markAsUpdated(): boolean

  Sets the entity as updated in the layer API.

  #### Returns boolean

  `true` if object did exist, otherwise `false`

### `Abstract` onAdded

- onAdded(o: MergableObjectEventArgs<MarkupEntityBase>): void

  Called when this entity is added

  #### Parameters

  - o: MergableObjectEventArgs<MarkupEntityBase>

  #### Returns void

  Implementation of MergableObject.onAdded

### `Abstract` onDelete

- onDelete(o: MergableObjectEventArgs<MarkupEntityBase>): void

  Called when this entity is deleted

  #### Parameters

  - o: MergableObjectEventArgs<MarkupEntityBase>

  #### Returns void

  Implementation of MergableObject.onDelete

### `Abstract` onUpdate

- onUpdate(o: MergableObjectEventArgs<MarkupEntityBase>): void

  Called when this entity is updated

  #### Parameters

  - o: MergableObjectEventArgs<MarkupEntityBase>

  #### Returns void

  Implementation of MergableObject.onUpdate